#include "./source/PlatformSpecific/inc/GOC.h"
#include "./source/PlatformSpecific/inc/DeviceInput.h"
                    
void GOC::Initilize()
{
	/* 
		Initilize your game scene, and game variables here. 
	*/

	// Ball's starting postion.
	PointGOC ballPosition_l = {GetWindowWidth() / 2,  
							   GetWindowHeight() / 2, 
							   0.0f};                 
                            
	// Initilze the ball.
	ball_m = new Sprite(); 
	ball_m->Set2DPosition(ballPosition_l,
						  24,                      
						  24);                     
    ball_m->GetTexture()->LoadTexture("./images/Ball.png");
    ball_m->SetVisible(false);
    //------------------------ 

    // Player one's starting postion.
    PointGOC playerOnePosition_l = {15,
                                    15,
                                    0};
    // Initilize player one.
    playerOne_m = new Sprite();
    playerOne_m->Set2DPosition(playerOnePosition_l,
                               15,
                               200);
    playerOne_m->GetTexture()->LoadTexture("./images/Padle.png");
    playerOne_m->SetVisible(true);
    //----------------------------

    // Player one's starting postion.
    PointGOC playerTwoPosition_l = {GetWindowWidth() - 30,
                                    15,
                                    0};
    // Initilize player two.
    playerTwo_m = new Sprite();
    playerTwo_m->Set2DPosition(playerTwoPosition_l,
                               15,
                               200);
    playerTwo_m->GetTexture()->LoadTexture("./images/Padle.png");
    playerTwo_m->SetVisible(true);
    //----------------------------
}
                    
void GOC::Update(TimeGOC *timeGOC_p, InputEngine *input_p)
{
	/*
		Update your game scenes, check for collisions, 
		check for input and play sounds here.
	*/

    // Move player two up and down with the mouse.
    playerTwo_m->SetYCor(input_p->YCordinate());

    // Move player one up 5 units when up is pressed.
    if(input_p->IsKeyOrButtonPressed(KeysAndButtons::UP_KEYBOARD))
    {
        playerOne_m->SetYCor(playerOne_m->GetYcor() - 20);
    }
    
    // Move player one down 5 units when down is pressed.
    if(input_p->IsKeyOrButtonPressed(KeysAndButtons::DOWN_KEYBOARD))
    {
        playerOne_m->SetYCor(playerOne_m->GetYcor() + 20);
    }
}
                        
void GOC::IndepedentUpdate(TimeGOC* timeGOC_p, InputEngine* input_p)
{
	/* 
		Update your game scenes, check for collisions, 
		check for input	and play sounds here.
	*/
}

void GOC::Destroy()
{
	/* 
		Clean up after your game here.
	*/
	
	// Destory your sprite when you are done with it.
	delete ball_m;

    // Destroy player One and player two.
    delete playerOne_m;
    delete playerTwo_m;
}
                    
#ifdef _WIN32
                    
	// Define the windows main funciton.
	int WINAPI WinMain(HINSTANCE hInstance, 
					   HINSTANCE hPrevInstance, 
					   LPSTR lpCmdLine, 
					   int nCmdShow)
                                           
#else
                    
	// Define the ubutnu main function.
	int main(int argc, char **argv)
                        
#endif
                    
	{
		#ifdef _WIN32
			// Start the GOC on windows.
			GOC::goc_i()->LoadGOC(hInstance);
		#else
			// Start the GOC on ubuntu.
			GOC::goc_i()->LoadGOC();
		#endif
                            
		// Destroy and cleanup GOC.
		GOC::goc_i()->UnloadGOC();
                            
		return 0;
	}
